clang-tools 6.0.0

Classes | Public Types | Public Member Functions | List of all members
clang::tidy::readability::IdentifierNamingCheck Class Reference

Checks for identifiers naming style mismatch. More...

`#include <IdentifierNamingCheck.h>`

Inheritance diagram for clang::tidy::readability::IdentifierNamingCheck:
[legend]
Collaboration diagram for clang::tidy::readability::IdentifierNamingCheck:
[legend]

## Classes
struct | NamingCheckFailure
| Holds an identifier name check failure, tracking the kind of the identifer, its possible fixup and the starting locations of all the identifier usages. More...
struct | NamingStyle

## Public Types
enum | CaseType { CT_AnyCase = 0, CT_LowerCase, CT_CamelBack, CT_UpperCase, CT_CamelCase, CT_CamelSnakeCase, CT_CamelSnakeBack }
typedef std::pair< SourceLocation, std::string > | NamingCheckId
typedef llvm::DenseMap< NamingCheckId, NamingCheckFailure > | NamingCheckFailureMap

## Public Member Functions
| IdentifierNamingCheck (StringRef Name, ClangTidyContext *Context)
void | storeOptions (ClangTidyOptions::OptionMap &Opts) override
| Should store all options supported by this check with their current values or default values for options that haven't been overridden. More...
void | registerMatchers (ast_matchers::MatchFinder *Finder) override
| Override this to register AST matchers with `Finder`. More...
void | check (const ast_matchers::MatchFinder::MatchResult &Result) override
| `ClangTidyChecks` that register ASTMatchers should do the actual work in here. More...
void | registerPPCallbacks (CompilerInstance &Compiler) override
| Override this to register `PPCallbacks` with `Compiler`. More...
void | onEndOfTranslationUnit () override
void | checkMacro (SourceManager &sourceMgr, const Token &MacroNameTok, const MacroInfo *MI)
| Check Macros for style violations. More...
void | expandMacro (const Token &MacroNameTok, const MacroInfo *MI)
| Add a usage of a macro if it already has a violation. More...
Public Member Functions inherited from clang::tidy::ClangTidyCheck
| ClangTidyCheck (StringRef CheckName, ClangTidyContext *Context)
| Initializes the check with `CheckName` and `Context`. More...
DiagnosticBuilder | diag (SourceLocation Loc, StringRef Description, DiagnosticIDs::Level Level=DiagnosticIDs::Warning)
| Add a diagnostic with the check's name. More...

## Additional Inherited Members
Protected Member Functions inherited from clang::tidy::ClangTidyCheck
StringRef | getCurrentMainFile () const
| Returns the main file name of the current translation unit. More...
LangOptions | getLangOpts () const
| Returns the language options from the context. More...
Protected Attributes inherited from clang::tidy::ClangTidyCheck
OptionsView | Options

## Detailed Description

Checks for identifiers naming style mismatch.

This check will try to enforce coding guidelines on the identifiers naming. It supports `lower_case`, `UPPER_CASE`, `camelBack` and `CamelCase` casing and tries to convert from one to another if a mismatch is detected.

It also supports a fixed prefix and suffix that will be prepended or appended to the identifiers, regardless of the casing.

Many configuration options are available, in order to be able to create different rules for different kind of identifier. In general, the rules are falling back to a more generic rule if the specific case is not configured.

Definition at line 35 of file IdentifierNamingCheck.h.

## Member Typedef Documentation

## ◆ NamingCheckFailureMap

typedef llvm::DenseMap<NamingCheckId, NamingCheckFailure> clang::tidy::readability::IdentifierNamingCheck::NamingCheckFailureMap

Definition at line 90 of file IdentifierNamingCheck.h.

## ◆ NamingCheckId

typedef std::pair<SourceLocation, std::string> clang::tidy::readability::IdentifierNamingCheck::NamingCheckId

Definition at line 87 of file IdentifierNamingCheck.h.

## Member Enumeration Documentation

## ◆ CaseType

enum clang::tidy::readability::IdentifierNamingCheck::CaseType

Enumerator
CT_AnyCase |
CT_LowerCase |
CT_CamelBack |
CT_UpperCase |
CT_CamelCase |
CT_CamelSnakeCase |
CT_CamelSnakeBack |

Definition at line 45 of file IdentifierNamingCheck.h.

## Constructor & Destructor Documentation

## ◆ IdentifierNamingCheck()

clang::tidy::readability::IdentifierNamingCheck::IdentifierNamingCheck | ( | StringRef | Name,
|  | ClangTidyContext * | Context
| ) |  |

Definition at line 157 of file IdentifierNamingCheck.cpp.

## Member Function Documentation

## ◆ check()

void clang::tidy::readability::IdentifierNamingCheck::check | ( | const ast_matchers::MatchFinder::MatchResult & | Result | ) |
| override virtual

`ClangTidyChecks` that register ASTMatchers should do the actual work in here.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 686 of file IdentifierNamingCheck.cpp.

References clang::tidy::readability::addUsage(), CT_LowerCase, DeclRef, clang::tidy::readability::findStyleKind(), clang::tidy::readability::IdentifierNamingCheck::NamingCheckFailure::Fixup, clang::tidy::readability::fixupWithCase(), clang::tidy::readability::fixupWithStyle(), clang::tidy::readability::IdentifierNamingCheck::NamingCheckFailure::KindName, Loc, clang::tidy::readability::matchesStyle(), Name, Range, and clang::tidy::readability::SK_Invalid.

## ◆ checkMacro()

void clang::tidy::readability::IdentifierNamingCheck::checkMacro | ( | SourceManager & | sourceMgr,
|  | const Token & | MacroNameTok,
|  | const MacroInfo * | MI
| ) |  |

Check Macros for style violations.

Definition at line 858 of file IdentifierNamingCheck.cpp.

## ◆ expandMacro()

void clang::tidy::readability::IdentifierNamingCheck::expandMacro | ( | const Token & | MacroNameTok,
|  | const MacroInfo * | MI
| ) |  |

Add a usage of a macro if it already has a violation.

Definition at line 892 of file IdentifierNamingCheck.cpp.

References clang::tidy::readability::addUsage(), Name, and Range.

## ◆ onEndOfTranslationUnit()

void clang::tidy::readability::IdentifierNamingCheck::onEndOfTranslationUnit | ( |  | ) |
| override

Definition at line 905 of file IdentifierNamingCheck.cpp.

References clang::tidy::ClangTidyCheck::diag(), clang::tidy::readability::IdentifierNamingCheck::NamingCheckFailure::Fixup, clang::tidy::readability::IdentifierNamingCheck::NamingCheckFailure::KindName, Loc, clang::tidy::readability::IdentifierNamingCheck::NamingCheckFailure::RawUsageLocs, and clang::tidy::readability::IdentifierNamingCheck::NamingCheckFailure::ShouldFix.

## ◆ registerMatchers()

void clang::tidy::readability::IdentifierNamingCheck::registerMatchers | ( | ast_matchers::MatchFinder * | Finder | ) |
| override virtual

Override this to register AST matchers with `Finder`.

This should be used by clang-tidy checks that analyze code properties that dependent on AST knowledge.

You can register as many matchers as necessary with `Finder`. Usually, "this" will be used as callback, but you can also specify other callback classes. Thereby, different matchers can trigger different callbacks.

If you need to merge information between the different matchers, you can store these as members of the derived class. However, note that all matches occur in the order of the AST traversal.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 226 of file IdentifierNamingCheck.cpp.

## ◆ registerPPCallbacks()

void clang::tidy::readability::IdentifierNamingCheck::registerPPCallbacks | ( | CompilerInstance & | Compiler | ) |
| override virtual

Override this to register `PPCallbacks` with `Compiler`.

This should be used for clang-tidy checks that analyze preprocessor- dependent properties, e.g. the order of include directives.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 236 of file IdentifierNamingCheck.cpp.

## ◆ storeOptions()

void clang::tidy::readability::IdentifierNamingCheck::storeOptions | ( | ClangTidyOptions::OptionMap & | Options | ) |
| override virtual

Should store all options supported by this check with their current values or default values for options that haven't been overridden.

The check should use `Options.store()` to store each option it supports whether it has the default value or it has been overridden.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 188 of file IdentifierNamingCheck.cpp.

References CT_AnyCase, CT_CamelBack, CT_CamelCase, CT_CamelSnakeBack, CT_CamelSnakeCase, CT_LowerCase, CT_UpperCase, clang::tidy::ClangTidyCheck::Options, clang::tidy::readability::SK_Count, clang::tidy::OptionsView::store(), and clang::tidy::cppcoreguidelines::toString().

The documentation for this class was generated from the following files:

- IdentifierNamingCheck.h
- IdentifierNamingCheck.cpp